Bug 1441813 - Review Request: colorful - simple side-view shooter game
Summary: Review Request: colorful - simple side-view shooter game
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Mikolaj Izdebski
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-04-12 18:58 UTC by Artur Iwicki
Modified: 2017-06-18 02:21 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-06-16 13:17:10 UTC
mizdebsk: fedora-review+


Attachments (Terms of Use)

Description Artur Iwicki 2017-04-12 18:58:51 UTC
Spec URL: https://svgames.pl/fedora/colorful-1.2-7.spec
SRPM URL: https://svgames.pl/fedora/colorful-1.2-7.src.rpm

koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=18953808
copr build: https://copr.fedorainfracloud.org/coprs/suve/colorful/build/539014/

Description: Colorful is a simple side-view shooter game, where the protagonist
travels a maze of caves and corridors in order to collect color artefacts.

Fedora Account System Username: suve

I am the upstream developer of this software.

As I am not a packager, I am looking for sponsorship and will be thankful for reviews.

Comment 1 Mikolaj Izdebski 2017-04-14 22:11:50 UTC
1. Licensing review: Some source files (bundled SDL_mixer.pas) seem to be licensed under MPL v1.1. License tag in spec file should reflect that. See: https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#License:_field

2. Missing BuildRequires: make, glibc-devel
All build-time dependencies must be listed as BuildRequires, even basic ones like make and glibc-devel. For more info, see: https://fedoraproject.org/wiki/Packaging:Guidelines#BuildRequires_2

3. You shouldn't list explicit requires on shared libraries. RPM will generate these requires automatically. See: https://fedoraproject.org/wiki/Packaging:Guidelines#Explicit_Requires

4. Requires on data package should be versioned. Otherwise RPM will happily allow users to install different (possibly incompatible) versions of game binary and data.

5. Desktop file is installed incorrectly (/usr/share/applications/colorful.desktop/colorful.desktop)

6. File ownership: directory /usr/share/suve is not owned. See: https://fedoraproject.org/wiki/Packaging:Guidelines#File_and_Directory_Ownership

7. It's nice to try to preserve timestamps when copying files (use cp -a instead of -R). See: https://fedoraproject.org/wiki/Packaging:Guidelines#Timestamps

Comment 2 Artur Iwicki 2017-04-15 12:32:30 UTC
Thank you for the thorough review.

1. I've added a patch which removes the need for the bundled library.

4. I've added an equal-version requirement.

6. I originally intended to group stuff needed by my software in /usr/share/suve, which would then contain sub-directories for programs. If I understand the wiki page correctly, multiple ownership shouldn't be a problem, so I went ahead and added the directory to the %files list. Still, if single ownership is the preferred solution, I can just make a patch that'll move the files to simply /usr/share/colorful. 

Points 2, 3, 5 and 7 have also been fixed.

spec: https://svgames.pl/fedora/colorful-1.2-9.spec
srpm: https://svgames.pl/fedora/colorful-1.2-9.src.rpm

koji: https://koji.fedoraproject.org/koji/taskinfo?taskID=19008565
copr: https://copr.fedorainfracloud.org/coprs/suve/colorful/build/539942/

Comment 3 Artur Iwicki 2017-05-20 08:42:02 UTC
I have ran the package through fedora-review. A few issues came up, so a new release was required.

spec: https://svgames.pl/fedora/colorful-1.2-10.spec
srpm: https://svgames.pl/fedora/colorful-1.2-10.src.rpm

koji: https://koji.fedoraproject.org/koji/taskinfo?taskID=19641008
copr: https://copr.fedorainfracloud.org/coprs/suve/colorful/build/554429/

For anyone running this though fedora-review: regarding parallel make flags - this software in written in Pascal, which means the compiler itself handles figuring out dependencies between code files. The Makefile is used pretty much only for defining compilation targets (debug / release / package) and setting up appropriate compiler flags.

Comment 4 Mikolaj Izdebski 2017-06-07 11:01:16 UTC
Sorry for delay. Package is approved now.
I would suggest changing requires on subpackage to be fully-versioned - "Requires: colorful-data = %{version}-%{release}"

Package Review
==============

Key:
- = N/A
x = Check
! = Problem

[x] rpmlint must be run on the source rpm and all binary rpms the
    build produces.  The output should be posted in the review.

[x] The package must be named according to the Package Naming
    Guidelines.

[x] The spec file name must match the base package %{name}, in the
    format %{name}.spec unless your package has an exemption.

[x] The package must meet the Packaging Guidelines.

[x] The package must be licensed with a Fedora approved license and
    meet the Licensing Guidelines.

[x] The License field in the package spec file must match the actual
    license.

[x] If (and only if) the source package includes the text of the
    license(s) in its own file, then that file, containing the text of
    the license(s) for the package must be included in %doc.

[x] The spec file must be written in American English.

[x] The spec file for the package MUST be legible.

[x] The sources used to build the package must match the upstream
    source, as provided in the spec URL.  Reviewers should use
    sha256sum for this task as it is used by the sources file once
    imported into git.  If no upstream URL can be specified for this
    package, please see the Source URL Guidelines for how to deal with
    this.

[x] The package MUST successfully compile and build into binary rpms
    on at least one primary architecture.

[x] If the package does not successfully compile, build or work on an
    architecture, then those architectures should be listed in the
    spec in ExcludeArch.  Each architecture listed in ExcludeArch MUST
    have a bug filed in bugzilla, describing the reason that the
    package does not compile/build/work on that architecture.  The bug
    number MUST be placed in a comment, next to the corresponding
    ExcludeArch line.

[x] All build dependencies must be listed in BuildRequires, except for
    any that are listed in the exceptions section of the Packaging
    Guidelines; inclusion of those as BuildRequires is optional.
    Apply common sense.

[x] The spec file MUST handle locales properly.  This is done by using
    the %find_lang macro.  Using %{_datadir}/locale/* is strictly
    forbidden.

[x] Every binary RPM package (or subpackage) which stores shared
    library files (not just symlinks) in any of the dynamic linker's
    default paths, must call ldconfig in %post and %postun.

[x] Packages must NOT bundle copies of system libraries.

[x] If the package is designed to be relocatable, the packager must
    state this fact in the request for review, along with the
    rationalization for relocation of that specific package.  Without
    this, use of Prefix: /usr is considered a blocker.

[x] A package must own all directories that it creates.  If it does
    not create a directory that it uses, then it should require a
    package which does create that directory.

[x] A Fedora package must not list a file more than once in the spec
    file's %files listings.  (Notable exception: license texts in
    specific situations.)

[x] Permissions on files must be set properly.  Executables should be
    set with executable permissions, for example.

[x] Each package must consistently use macros.

[x] The package must contain code, or permissible content.

[x] Large documentation files must go in a -doc subpackage.  (The
    definition of large is left up to the packager's best judgement,
    but is not restricted to size.  Large can refer to either size or
    quantity).

[x] If a package includes something as %doc, it must not affect the
    runtime of the application.  To summarize: If it is in %doc, the
    program must run properly if it is not present.

[x] Static libraries must be in a -static package.

[x] Development files must be in a -devel package.

[x] In the vast majority of cases, devel packages must require the
    base package using a fully versioned dependency: Requires:
    %{name}%{?_isa} = %{version}-%{release}

[x] Packages must NOT contain any .la libtool archives, these must be
    removed in the spec if they are built.

[x] Packages containing GUI applications must include a
    %{name}.desktop file, and that file must be properly installed
    with desktop-file-install in the %install section.  If you feel
    that your packaged GUI application does not need a .desktop file,
    you must put a comment in the spec file with your explanation.

[x] Packages must not own files or directories already owned by other
    packages.  The rule of thumb here is that the first package to be
    installed should own the files or directories that other packages
    may rely upon.  This means, for example, that no package in Fedora
    should ever share ownership with any of the files or directories
    owned by the filesystem or man package.  If you feel that you have
    a good reason to own a file or directory that another package
    owns, then please present that at package review time.

[x] All filenames in rpm packages must be valid UTF-8.


rpmlint output
--------------

colorful.x86_64: W: only-non-binary-in-usr-lib
colorful.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
colorful.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
colorful-data.noarch: W: no-documentation
4 packages and 0 specfiles checked; 0 errors, 4 warnings.

Comment 5 Gwyn Ciesla 2017-06-07 12:48:45 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/colorful

Comment 6 Fedora Update System 2017-06-08 06:30:06 UTC
colorful-1.2-11.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-5bf94e21ff

Comment 7 Fedora Update System 2017-06-08 06:30:43 UTC
colorful-1.2-11.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-b8e1201d19

Comment 8 Fedora Update System 2017-06-08 06:31:24 UTC
colorful-1.2-11.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-7341f0c642

Comment 9 Fedora Update System 2017-06-09 13:31:31 UTC
colorful-1.2-11.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-7341f0c642

Comment 10 Fedora Update System 2017-06-09 13:39:33 UTC
colorful-1.2-11.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-b8e1201d19

Comment 11 Fedora Update System 2017-06-10 01:08:56 UTC
colorful-1.2-11.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-5bf94e21ff

Comment 12 Fedora Update System 2017-06-16 13:17:10 UTC
colorful-1.2-11.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.

Comment 13 Fedora Update System 2017-06-18 01:18:01 UTC
colorful-1.2-11.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 14 Fedora Update System 2017-06-18 02:21:59 UTC
colorful-1.2-11.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.